/*
	LUSScreenSaver Plugin LUSSSExeKicker ( Executable File Kicker )
	Copyright (C) 2003 ONO,Masayuki.<mono101@skill-engineering.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "LUSSSExeKickerSetting.h"
#include <qfile.h>
#include <qradiobutton.h>
#include <qbuttongroup.h>
#include <qpushbutton.h>
#include <qlayout.h>
#include <qvariant.h>
#include <qwhatsthis.h>
#include <qlineedit.h>
#include <qcheckbox.h>
#include <qlabel.h>
#include <qspinbox.h>
#include <qgroupbox.h>
#include <qpe/config.h>
#include <qpe/qpeapplication.h>
#include <sl/slfileselector.h>

#include <qtextcodec.h>
#define _T(str) QTextCodec::codecForLocale()->toUnicode(str)

LUSSSExeBrowser::LUSSSExeBrowser( const QString& dir, QWidget* parent,  const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
	setWState( WState_Reserved1 );

	if ( !name )
	{
		setName( "LUSSSExeBrowser" );
	}
	setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)5,
												sizePolicy().hasHeightForWidth() ) );
	QString caption;
	caption = _T( "¹ԥե" );
	setCaption( caption );

	BaseLayout = new QVBoxLayout( this ); 
	BaseLayout->setSpacing( 6 );
	BaseLayout->setMargin( 11 );

	ExeBrowser = new SlFileSelector( dir, "*/*", this, "ExeBrowser" );
	ExeBrowser->setFocusMode( SlFileSelector::ByTab );
	BaseLayout->addWidget( ExeBrowser );

	showMaximized();
	setFocus();
}

LUSSSExeBrowser::~LUSSSExeBrowser()
{
}

void LUSSSExeBrowser::closeEvent( QCloseEvent *e )
{
	e->accept();
}

void LUSSSExeBrowser::accept()
{
	m_sPath = ExeBrowser->currentFile();
	emit done( Accepted );
	close();
}

void LUSSSExeBrowser::reject()
{
	close();
}

QString LUSSSExeBrowser::getPath()
{
	return m_sPath;
}

LUSSSExeKickerSetting::LUSSSExeKickerSetting( QWidget* parent,  const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
	if ( ! name )
	{
		setName( "SettingDialog" );
	}

	setCaption( "SETTINGS" );

	BaseLayout = new QVBoxLayout( this ); 
	BaseLayout->setSpacing( 6 );
	BaseLayout->setMargin( 11 );

	BaseGroupBox = new QGroupBox( this, "BaseGroupBox" );
	BaseGroupBox->setTitle( "" );
	BaseGroupBox->setColumnLayout(0, Qt::Vertical );
	BaseGroupBox->layout()->setSpacing( 0 );
	BaseGroupBox->layout()->setMargin( 0 );
	BaseGroupBoxLayout = new QVBoxLayout( BaseGroupBox->layout() );
	BaseGroupBoxLayout->setAlignment( Qt::AlignTop );
	BaseGroupBoxLayout->setSpacing( 6 );
	BaseGroupBoxLayout->setMargin( 11 );

	StartExeFuncLayout = new QHBoxLayout( this );
	StartExeFuncLayout->setSpacing( 6 );
	StartExeFuncLayout->setMargin( 11 );

	StopExeFuncLayout = new QHBoxLayout( this );
	StopExeFuncLayout->setSpacing( 6 );
	StopExeFuncLayout->setMargin( 11 );

	DefButtonsLayout = new QHBoxLayout( this );
	DefButtonsLayout->setSpacing( 6 );
	DefButtonsLayout->setMargin( 11 );

	Config cfg( "LUSScreenSaver" );
	cfg.setGroup( "LUSSSExeKicker" );

	StartExeFuncLabel = new QLabel( _T( "ϻ¹ԥե" ), BaseGroupBox, "StartExeFuncLabel" );

	StartExeEdit = new QLineEdit( BaseGroupBox, "StartExeEdit" );
	QString pathStartExe = cfg.readEntry( "StartApp" );
	StartExeEdit->setText( pathStartExe );

	BrowseStartExeButton = new QPushButton( BaseGroupBox, "BrowseStartExeButton" );
	BrowseStartExeButton->setText( "..." );

	StartExeFuncLayout->addWidget( StartExeEdit );
	StartExeFuncLayout->addWidget( BrowseStartExeButton );

	StopExeFuncLabel = new QLabel( _T( "߻¹ԥե" ), BaseGroupBox, "StopExeFuncLabel" );

	StopExeEdit = new QLineEdit( BaseGroupBox, "StopExeEdit" );
	QString pathStopExe = cfg.readEntry( "StopApp" );
	StopExeEdit->setText( pathStopExe );

	BrowseStopExeButton = new QPushButton( BaseGroupBox, "BrowseStopExeButton" );
	BrowseStopExeButton->setText( "..." );

	StopExeFuncLayout->addWidget( StopExeEdit );
	StopExeFuncLayout->addWidget( BrowseStopExeButton );

	FuncSelectGroup = new QButtonGroup( 3, QGroupBox::Horizontal, _T("¹Դؿ"), BaseGroupBox );
	FuncSelectGroup->setExclusive( TRUE );

	FuncInvoke = new QRadioButton( "invoke", FuncSelectGroup );
	FuncExecute = new QRadioButton( "execute", FuncSelectGroup );
	FuncSystem = new QRadioButton( "system", FuncSelectGroup );

	switch ( cfg.readNumEntry( "Func", 0 ) )
	{
	case 0:
		FuncInvoke->setChecked( TRUE );
		break;
	case 1:
		FuncExecute->setChecked( TRUE );
		break;
	case 2:
		FuncSystem->setChecked( TRUE );
		break;
	default:
		FuncInvoke->setChecked( TRUE );
		break;
	}

	PushButton1 = new QPushButton( this, "PushButton1" );
	PushButton1->setText( _T( "Ŭ" ) );

	PushButton2 = new QPushButton( this, "PushButton2" );
	PushButton2->setText( _T( "󥻥" ) );
	
	DefButtonsLayout->addWidget( PushButton1 );
	DefButtonsLayout->addWidget( PushButton2 );

	BaseGroupBoxLayout->addWidget( StartExeFuncLabel );
	BaseGroupBoxLayout->addLayout( StartExeFuncLayout );
	BaseGroupBoxLayout->addWidget( StopExeFuncLabel );
	BaseGroupBoxLayout->addLayout( StopExeFuncLayout );
	BaseGroupBoxLayout->addWidget( FuncSelectGroup );
	BaseLayout->addWidget( BaseGroupBox );
	BaseLayout->addLayout( DefButtonsLayout );
	
	connect( BrowseStartExeButton, SIGNAL( clicked() ), this, SLOT( browseStartExe() ) );
	connect( BrowseStopExeButton, SIGNAL( clicked() ), this, SLOT( browseStopExe() ) );
	connect( PushButton1 ,SIGNAL( clicked() ), this, SLOT( accept() ) );
	connect( PushButton2 ,SIGNAL( clicked() ), this, SLOT( close() ) );

	showMaximized();
	StartExeEdit->setFocus();
}

void LUSSSExeKickerSetting::browseStartExe()
{
	LUSSSExeBrowser dlg( StartExeEdit->text(), this, "Exe. Selector", TRUE, WType_Modal );
	if ( dlg.exec() == QDialog::Accepted )
	{
		QString sPath = dlg.getPath();
		StartExeEdit->setText( sPath );
	}
}

void LUSSSExeKickerSetting::browseStopExe()
{
	LUSSSExeBrowser dlg( StopExeEdit->text(), this, "Exe. Selector", TRUE, WType_Modal );
	if ( dlg.exec() == QDialog::Accepted )
	{
		QString sPath = dlg.getPath();
		StopExeEdit->setText( sPath );
	}
}

void LUSSSExeKickerSetting::accept()
{
	Config cfg( "LUSScreenSaver" );
	cfg.setGroup( "LUSSSExeKicker" );

	cfg.writeEntry( "StartApp", StartExeEdit->text() );
	cfg.writeEntry( "StopApp", StopExeEdit->text() );

	if ( FuncInvoke->isChecked() )
	{
		cfg.writeEntry( "Func", 0 );
	}
	else if ( FuncExecute->isChecked() )
	{
		cfg.writeEntry( "Func", 1 );
	}
	else if ( FuncSystem->isChecked() )
	{
		cfg.writeEntry( "Func", 2 );
	}

	close();
}

void LUSSSExeKickerSetting::reject()
{
	close();
}

void LUSSSExeKickerSetting::closeEvent( QCloseEvent* e )
{
	e->accept();
}


LUSSSExeKickerSetting::~LUSSSExeKickerSetting()
{
    // no need to delete child widgets, Qt does it all for us
}

