/*
	LUSScreenSaver Plugin LUSSSExeKicker ( Executable File Kicker )
	Copyright (C) 2003 ONO,Masayuki.<mono101@skill-engineering.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef _LESS_UNSATICEFACTORY_SCREENSAVER_EXE_KICKER_SETTING_H_
#define _LESS_UNSATICEFACTORY_SCREENSAVER_EXE_KICKER_SETTING_H_

#include <qvariant.h>
#include <qdialog.h>

class QVBoxLayout;
class QHBoxLayout;
class QGridLayout;
class QRadioButton;
class QButtonGroup;
class QLabel;
class QLineEdit;
class QPushButton;
class QSpinBox;
class QGroupBox;
class QCheckBox;
class SlFileSelector;

class LUSSSExeBrowser : public QDialog
{
Q_OBJECT

public:
	LUSSSExeBrowser( const QString& dir, QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
	~LUSSSExeBrowser();
	QString getPath();

private:
	QVBoxLayout * BaseLayout;
	SlFileSelector * ExeBrowser;
	QString m_sPath;

protected:
	void closeEvent( QCloseEvent * );

protected slots:
	void accept();
	void reject();
};

class LUSSSExeKickerSetting : public QDialog
{
Q_OBJECT

public:
	LUSSSExeKickerSetting( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
	~LUSSSExeKickerSetting();

private:
	QVBoxLayout*	BaseLayout;

	QGroupBox*		BaseGroupBox;
	QVBoxLayout*	BaseGroupBoxLayout;

	QLabel*			StartExeFuncLabel;
	QHBoxLayout*	StartExeFuncLayout;
	QLineEdit* 		StartExeEdit;
	QPushButton*	BrowseStartExeButton;

	QLabel*			StopExeFuncLabel;
	QHBoxLayout*	StopExeFuncLayout;
	QLineEdit* 		StopExeEdit;
	QPushButton*	BrowseStopExeButton;

	QButtonGroup*	FuncSelectGroup;
	QRadioButton*	FuncInvoke;
	QRadioButton*	FuncExecute;
	QRadioButton*	FuncSystem;

	QHBoxLayout*	DefButtonsLayout;
	QPushButton*	PushButton1;
	QPushButton*	PushButton2;

protected:
	void closeEvent( QCloseEvent * );

protected slots:
	void accept();
	void reject();
	void browseStartExe();
	void browseStopExe();
};

#endif // _LESS_UNSATICEFACTORY_SCREENSAVER_EXE_KICKER_SETTING_H_
